/*
 *   Returns time in seconds (double precision)
 *
 *   By Sidney Li 5/23/95 
 *   compile with: gcc -c -I /usr/include/tcl getuclock.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* for timer */

#include <sys/time.h>
#include <unistd.h>

#include <tcl.h>

/*                        01234567890123456789012345678901 */
static char ib_curtime[]="                                ";

int getuclock_init ( Tcl_Interp *interp ){

extern int ib_GetUClockCmd _ANSI_ARGS_(( ClientData clientData,
			      Tcl_Interp *interp,
			       int argc,
			       char *argv[]
			       ));

    Tcl_CreateCommand(interp,"getuclock",ib_GetUClockCmd,
		         (ClientData) NULL,
			 (Tcl_CmdDeleteProc *) NULL );
    return TCL_OK;
}


int getuclock_cleanup ( Tcl_Interp *interp ){

  Tcl_DeleteCommand(interp,"getuclock");

  return TCL_OK;
}

/**********************************************************************/


int
ib_GetUClockCmd _ANSI_ARGS_(( ClientData clientData,
			      Tcl_Interp *interp,
			       int argc,
			       char *argv[]
			       )) 
{
  static struct timeval mytv;

  if (argc != 1) {
      interp->result = "wrong # args";
      return TCL_ERROR;
  }

  if ( gettimeofday(&mytv, NULL) ) {
      interp->result = "can't get current time";
      return TCL_ERROR;
  }
/* approx 
 * 150--180 microseconds to execute on 486 33MHz
 * 115      microseconds to execute on 486 66MHz
 * 51       microseconds to execute on 586 90MHz
 */
  sprintf(ib_curtime, "%ld.%06ld\0", mytv.tv_sec, mytv.tv_usec);

/* approx 500 microseconds to execute (on 486 33MHz)
 * sprintf(ib_curtime, "%.6lf\0", mytv.tv_sec+ 1.0e-6*mytv.tv_usec);
 */

  interp->result = ib_curtime;
  
  return TCL_OK;
}
